﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Security.Cryptography.X509Certificates;
using System.Security.Cryptography;
using System.IO;
using System.Windows;
using System.Windows.Forms;

namespace YaroStat
{
    public class c_standart
    {
        Form f;

        // fields
        //

        // constructor
        public c_standart(Form _f)
        {
            f = _f;
        }

        // OLDSCHOOL
        public string[] EncXXI(string data, char sharp)
        {
            String[] substrings = data.Split( sharp );

            return substrings;
        }

        // UNIX
        public int get_UNIX_INT32()
        {
            Int32 unixTimestamp = (Int32) ( DateTime.UtcNow.Subtract( new DateTime( 1970, 1, 1 ) ) ).TotalSeconds;
            string s = unixTimestamp.ToString();

            return Convert.ToInt32( s );
        }
        public string get_UNIX_STRING()
        {
            Int32 unixTimestamp = (Int32) ( DateTime.UtcNow.Subtract( new DateTime( 1970, 1, 1 ) ) ).TotalSeconds;
            string s = unixTimestamp.ToString();

            int j = Convert.ToInt32( s );

            return j.ToString();
        }

        // MD5
        public string get_MD5_Lowercase(string source)
        {
            MD5 md5Hash = MD5.Create();

            string hash = GetMd5Hash( md5Hash, source );

            return hash.ToLower();
        }
        public string get_MD5_Uppercase(string source)
        {
            MD5 md5Hash = MD5.Create();

            string hash = GetMd5Hash( md5Hash, source );

            return hash.ToUpper();
        }
        static string GetMd5Hash(MD5 md5Hash, string input)
        {

            // Convert the input string to a byte array and compute the hash.
            byte[] data = md5Hash.ComputeHash( Encoding.UTF8.GetBytes( input ) );

            // Create a new Stringbuilder to collect the bytes
            // and create a string.
            StringBuilder sBuilder = new StringBuilder();

            // Loop through each byte of the hashed data 
            // and format each one as a hexadecimal string.
            for (int i = 0; i < data.Length; i++)
            {
                sBuilder.Append( data[i].ToString( "x2" ) );
            }

            // Return the hexadecimal string.
            return sBuilder.ToString();
        }

        // APPLICATION
        public string ExtractApplicationPathExename()
        {
            return System.Reflection.Assembly.GetExecutingAssembly().Location;
        }

        // CONVERTERS
        public string convert_MemoryStream_to_String(MemoryStream ms)
        {
            StreamReader sr = new StreamReader( ms );
            string j = sr.ReadToEnd();

            return j;
        }
        public string convert_ListArray_to_String(List<string> Array)
        {
            string j = "";

            for (int c = 0; c < Array.Count; c++)
            {
                j = j + Array[c];

                if (c + 1 < Array.Count)
                    j = j + "\n";
            }

            return j;
        }
        public byte[] convert_String_to_Byte(string data)
        {
            byte[] array = System.Text.Encoding.Default.GetBytes( data );

            return array;
        }
        public string convert_Byte_to_String(byte[] Byte)
        {
            string j = System.Text.Encoding.Default.GetString( Byte );

            return j;
        }

        // OPERATIONS
        public bool MessageBox(string Caption, string Message)
        {
            bool jYES = false;

            MessageBoxButtons buttons = MessageBoxButtons.YesNo;
            DialogResult result = System.Windows.Forms.MessageBox.Show( Message, Caption, buttons );

            if (result == System.Windows.Forms.DialogResult.Yes)
            {
                jYES = true;
            }

            return jYES;
        }
        public string LoadFromFile_S(string file)
        {
            string j = "";

            string[] carray = System.IO.File.ReadAllLines( file );

            for (int c = 0; c < carray.Length; c++)
                j = j + carray[c] + "\n";

            return j;
        }
        public string LoadFromFile_S_ENCDEF( string file )
        {
            string j = "";

            string[] carray = System.IO.File.ReadAllLines( file, Encoding.Default );

            for ( int c = 0; c < carray.Length; c++ )
                j = j + carray[c] + "\n";

            return j;
        }
        public List<string> LoadFromFile_L(string file)
        {
            List<string> L = new List<string>();

            string[] carray = System.IO.File.ReadAllLines( file );

            for (int c = 0; c < carray.Length; c++)
                L.Add( carray[c] );

            return L;
        }
        public List<string> LoadFromFile_L_ENCDEF( string file )
        {
            List<string> L = new List<string>();

            string[] carray = System.IO.File.ReadAllLines( file, Encoding.Default );

            for ( int c = 0; c < carray.Length; c++ )
                L.Add( carray[c] );

            return L;
        }
        public void SaveToFile_UTF8(string data, string file)
        {
            byte[] array = System.Text.Encoding.UTF8.GetBytes( data );

            System.IO.File.WriteAllBytes( file, array );
        }
        public void SaveToFile_DEFAULT(string data, string file)
        {
            byte[] array = System.Text.Encoding.Default.GetBytes( data );

            System.IO.File.WriteAllBytes( file, array );
        }
    }
}
