﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace YaroStat
{
    public partial class f : Form
    {
        // fields
        c_standart std;

        // constructor
        public f()
        {
            InitializeComponent();

            std = new c_standart( this );
        }
        private void f_Load( object sender, EventArgs e )
        {
            load_last_dimfile();
        }
        //
        void log( string data )
        {
            textBox1.AppendText( data+"\r\n" );
        }

        // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // 
        // symwordsorter

        private void sws_process()
        {
            string fline = "";
            for ( int x = 0; x < inctext.Text.Length; x++ )
            {
                char cha = inctext.Text[x];
                int cd = inctext.Text[x];
                if ( cd == 13 || cd == 10 )
                {
                    if ( cd == 13 )
                        fline += " ";
                }
                else
                    fline += cha;
            }

            string[] dirtwords = fline.Split( ' ' );

            for ( int c = 0; c < dirtwords.Length; c++ )
            {
                string clearword = dirtwords[c].ToLower();
                clearword = sws_filter( clearword );

                bool ex = false;

                for ( int i = 0; i < LV_SimSorter.Items.Count; i++ )
                {
                    string w = LV_SimSorter.Items[i].Text;
                    int count = Convert.ToInt32( LV_SimSorter.Items[i].SubItems[1].Text );

                    if ( w == clearword )
                    {
                        ex = true;
                        LV_SimSorter.Items[i].SubItems[1].Text = ( count + 1 ).ToString();
                        break;
                    }
                }

                if ( !ex )
                {
                    int index = LV_SimSorter.Items.Add( "" ).Index;
                    LV_SimSorter.Items[index].SubItems.Clear();
                    LV_SimSorter.Items[index].Text = clearword;
                    LV_SimSorter.Items[index].SubItems.Add( "1" );
                }
            }
        }
        //
        private string sws_filter( string dirtword )
        {
            string buff = "";

            for ( int c = 0; c < dirtword.Length; c++ )
            {
                char CH = dirtword[c];
                int code = dirtword[c];

                string dstring = "!@#$%^&*()-_=+1234567890.><,\\|[]{}~:\"";

                if ( dstring.IndexOf( CH ) == -1 )
                {
                    buff += CH;
                }
            }

            return buff;
        }

        // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // 
        // dichotomy

        private void dim_process()
        {
            write_60();

            go();

            fix_noise();
        }
        //
        private void write_60()
        {
            for ( int c = 0; c < LV_DIM_SOURCE.Items.Count; c++ )
            {
                string a = LV_DIM_SOURCE.Items[c].SubItems[1].Text;
                string b = LV_DIM_SOURCE.Items[c].SubItems[2].Text;

                int index = LV_DIM_DEST.Items.Add( "" ).Index;
                LV_DIM_DEST.Items[index].SubItems.Clear();
                LV_DIM_DEST.Items[index].Text = ( c + 1 ).ToString();
                LV_DIM_DEST.Items[index].SubItems.Add( a );  
                LV_DIM_DEST.Items[index].SubItems.Add( b );
                LV_DIM_DEST.Items[index].SubItems.Add( "" );
                LV_DIM_DEST.Items[index].SubItems.Add( "" );
                LV_DIM_DEST.Items[index].SubItems.Add( "" );
                LV_DIM_DEST.Items[index].SubItems.Add( "" );
                LV_DIM_DEST.Items[index].SubItems.Add( "" );
                LV_DIM_DEST.Items[index].SubItems.Add( "" );
                LV_DIM_DEST.Items[index].SubItems.Add( "" );
                LV_DIM_DEST.Items[index].SubItems.Add( "" );
                LV_DIM_DEST.Items[index].SubItems.Add( "" );
                LV_DIM_DEST.Items[index].SubItems.Add( "" );
                LV_DIM_DEST.Items[index].SubItems.Add( "" );
                LV_DIM_DEST.Items[index].SubItems.Add( "" );
                LV_DIM_DEST.Items[index].SubItems.Add( "" );
                LV_DIM_DEST.Items[index].SubItems.Add( "" );
                LV_DIM_DEST.Items[index].SubItems.Add( "" );
                LV_DIM_DEST.Items[index].SubItems.Add( "" );
                LV_DIM_DEST.Items[index].SubItems.Add( "" );
                LV_DIM_DEST.Items[index].SubItems.Add( "" );
                LV_DIM_DEST.Items[index].SubItems.Add( "" );
                LV_DIM_DEST.Items[index].SubItems.Add( "" );
                LV_DIM_DEST.Items[index].SubItems.Add( "" );
                LV_DIM_DEST.Items[index].SubItems.Add( "" );
                LV_DIM_DEST.Items[index].SubItems.Add( "" );

                if ( c + 1 >= Convert.ToInt32( e_dim_max.Text.Trim() ) )
                    break;
            }
        }
        private void go()
        {
            string dir = Environment.CurrentDirectory + "\\Dichotomy";
            string[] typedirs = Directory.GetDirectories( dir );

            for ( int a = 0; a < LV_DIM_DEST.Items.Count; a++ )
            {
                string word  = LV_DIM_DEST.Items[a].SubItems[1].Text;
                string count = LV_DIM_DEST.Items[a].SubItems[2].Text;

                log( " " );
                log( "Обработка строки № [ " + (a+1).ToString() +" ] , Слово [ " + word + " ], К-во [ "+ count + " ] ..." );

                // dirs
                for ( int c = 0; c < typedirs.Length; c++ )
                {
                    string typedir = typedirs[c];
                    string[] files = Directory.GetFiles( typedir );
                    string file_1 = files[0];
                    string file_2 = files[1];
                    string file_k = files[2];

                    #region e-types 
                    if ( c == 0 )
                        log( "Для [ экст ] :" );
                    if ( c == 1 )
                        log( "Для [ инту ] :" );
                    if ( c == 2 )
                        log( "Для [ логи ] :" );
                    if ( c == 3 )
                        log( "Для [ ирра ] :" );
                    if ( c == 4 )
                        log( "Для [ бесп ] :" );
                    if ( c == 5 )
                        log( "Для [ усту ] :" );
                    if ( c == 6 )
                        log( "Для [ стат ] :" );
                    if ( c == 7 )
                        log( "Для [ де ] :" );
                    if ( c == 8 )
                        log( "Для [ такт ] :" );
                    if ( c == 9 )
                        log( "Для [ конс ] :" );
                    if ( c == 10 )
                        log( "Для [ пози ] :" );
                    if ( c == 11 )
                        log( "Для [ расс ] :" );
                    if ( c == 12 )
                        log( "Для [ весе ] :" );
                    if ( c == 13 )
                        log( "Для [ проц ] :" );
                    if ( c == 14 )
                        log( "Для [ квес ] :" );
                    if ( c == 15 )
                        log( "Для [ мж ] :" );
                    if ( c == 16 )
                        log( "Для [ россукр ] :" );
                    if ( c == 17 )
                        log( "Для [ стмл ] :" );
                    #endregion
                    write_result( a, word, count, c, file_1, file_2, file_k );
                }
            }
        }
        private void write_result( int IndexLV, string dimWORD, string dimCOUNT, int indexDir, string f1, string f2, string fk )
        {
            List<string> ListFile1 = std.LoadFromFile_L_ENCDEF( f1 );
            List<string> ListFile2 = std.LoadFromFile_L_ENCDEF( f2 );
            double K = Convert.ToDouble( doublefix(           std.LoadFromFile_S( fk ).Trim()     ) );

            double RES1 = 0, RES2 = 0, RES3 = 0;

            for ( int c1 = 0; c1 < ListFile1.Count; c1++ )
            {
                ListFile1[c1] = ListFile1[c1].Trim();
                string[] arr = ListFile1[c1].Split(' ');
                if ( arr.Length == 2 )
                {
                    string w = arr[0];
                    int n = Convert.ToInt32( arr[1].Trim() );
                    if ( dimWORD == w )
                    {
                        RES1 = n * K;
                        log("Значение из файла 1: " +n.ToString());
                        break;
                    }
                }
            }

            for ( int c2 = 0; c2 < ListFile2.Count; c2++ )
            {
                ListFile2[c2] = ListFile2[c2].Trim();
                string[] arr = ListFile2[c2].Split( ' ' );
                if ( arr.Length == 2 )
                {
                    string w = arr[0];
                    int n = Convert.ToInt32( arr[1].Trim() );
                    if ( dimWORD == w )
                    {
                        RES2 = n;
                        log( "Значение из файла 2: " + n.ToString() );
                        break;
                    }
                }
            }

            RES3 = RES1 / RES2;

            log( "Значение K: " + K.ToString() );
            log( "Переменная RES-1: " + RES1.ToString() );
            log( "Переменная RES-2: " + RES2.ToString() );
            log( "Переменная RES-3: " + RES3.ToString() );

            LV_DIM_DEST.Items[IndexLV].SubItems[3+ indexDir].Text = fix3( RES3 );

            Application.DoEvents();
        }
        //
        private string doublefix( string src )
        {
            string buff = "";

            for ( int c = 0; c < src.Length; c++ )
            {
                char ch = src[c];
                if ( ch == '.' )
                    ch = ',';

                buff += ch;
            }

            return buff;
        }
        private string doubleAfix( string src )
        {
            string buff = "";

            for ( int c = 0; c < src.Length; c++ )
            {
                char ch = src[c];
                if ( ch == ',' )
                    ch = '.';

                buff += ch;
            }

            return buff;
        }
        private string fix3( double RES3 )
        {
            RES3 = Math.Round( RES3, 2 );

            string result = RES3.ToString();

            if ( RES3 <= Convert.ToDouble( koof_preobladanie.Text.Trim() ) && RES3 >= 1 / Convert.ToDouble(koof_preobladanie.Text.Trim()) )
            {
                result = "__";
            }

            if ( RES3 < 1 / Convert.ToDouble(koof_preobladanie.Text.Trim()))
            {
                RES3 = 1 / RES3;

                RES3 = Math.Round( RES3, 2 );

                result = "A " + RES3.ToString();
            }

            return result;
        }
        private void fix_noise()
        {
            for ( int c = 0; c < LV_DIM_DEST.Items.Count; c++ )
            {
                log( "Фиксация шумов на строке [ " + ( c + 1 ).ToString() + " ]" );

                double max = 0;

                for ( int x = 3; x <= 20; x++ )
                {
                    string A = LV_DIM_DEST.Items[c].SubItems[x].Text;

                    log( "A = " + A );

                    if ( A != "__" )
                    {
                        if ( A.IndexOf( "A" ) != -1 )
                        {
                            A = A.Substring( 2 );
                        }

                        if ( Convert.ToDouble( A ) > max )
                        {
                            max = Convert.ToDouble( A );

                            log( "Принято за max дихотомия [ " + ( x - 3 ).ToString() + " ]" );
                        }
                    }
                }

                if ( max != 0 )
                {
                    double res = max / Convert.ToDouble( koof_shum.Text.Trim() );

                    for ( int x = 3; x <= 20; x++ )
                    {
                        string A = LV_DIM_DEST.Items[c].SubItems[x].Text;

                        if ( A != "__" )
                        {
                            if ( A.IndexOf( "A" ) != -1 )
                            {
                                A = A.Substring( 2 );
                            }

                            double a = Convert.ToDouble( A );

                            if ( a < res )
                            {
                                LV_DIM_DEST.Items[c].SubItems[x].Text = "ШУМ";
                            }
                        }
                    }
                }
            }
        }
        //
        private void output()
        {
            if ( SD_DICHOTOMY.ShowDialog() == DialogResult.OK )
            {
                string buff = "";

                for ( int c = 0; c < LV_DIM_DEST.Items.Count; c++ )
                {
                    for ( int x = 0; x < 21; x++ )
                    {
                        buff += LV_DIM_DEST.Items[c].SubItems[x].Text;

                        if ( x < 20 )
                            buff += "\t";
                    }

                    if ( c < LV_DIM_DEST.Items.Count-1 )
                        buff += "\r\n";
                }

                std.SaveToFile_DEFAULT( doubleAfix( buff ), SD_DICHOTOMY.FileName );

                MessageBox.Show("Готово!");
            }
        }
        //
        private string get_last_dimfile()
        {
            string j = "";

            try
            {
                string file = Environment.CurrentDirectory + "\\Cache\\LastDim.txt";

                j = std.LoadFromFile_S_ENCDEF( file );
            }
            catch ( Exception ex )
            {
                string a = ""; a = ex.Message;
            }

            return j;
        }
        private void set_last_dimfile( string data )
        {
            try
            {
                string file = Environment.CurrentDirectory + "\\Cache\\LastDim.txt";

                std.SaveToFile_DEFAULT( data, file );
            }
            catch ( Exception ex )
            {
                string a = "";
                a = ex.Message;
            }
        }
        private void load_last_dimfile()
        {
            string last = get_last_dimfile();

            if ( last.Trim().Length > 0 )
            {
                try
                {
                    e_dim_filepath.Text = last;
                    //
                    List<string> L = std.LoadFromFile_L_ENCDEF( last.Trim() );
                    for ( int c = 0; c < L.Count; c++ )
                    {
                        L[c] = L[c].Trim();
                        string[] arr = L[c].Split( ' ' );
                        if ( arr.Length == 2 )
                        {
                            string a = arr[0].Trim();
                            string b = arr[1].Trim();

                            int index = LV_DIM_SOURCE.Items.Add( "" ).Index;
                            LV_DIM_SOURCE.Items[index].SubItems.Clear();
                            LV_DIM_SOURCE.Items[index].Text = ( c + 1 ).ToString();
                            LV_DIM_SOURCE.Items[index].SubItems.Add( a );
                            LV_DIM_SOURCE.Items[index].SubItems.Add( b );
                        }
                    }
                }
                catch ( Exception ex )
                {
                    MessageBox.Show( ex.Message );
                }
            }
        }

        // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // 

        // fastcalls - buttons open
        private void b_sws_openfile_Click( object sender, EventArgs e )
        {
            if ( OD_SYMWORD.ShowDialog() == DialogResult.OK )
            {
                e_sws_filepath.Text = OD_SYMWORD.FileName;
                //
                inctext.Text = File.ReadAllText( OD_SYMWORD.FileName, Encoding.Default );
            }
        }
        private void b_dim_openfile_Click( object sender, EventArgs e )
        {
            if ( OD_DICHOTOMY.ShowDialog() == DialogResult.OK )
            {
                e_dim_filepath.Text = OD_DICHOTOMY.FileName;
                //
                List<string> L = std.LoadFromFile_L_ENCDEF( OD_DICHOTOMY.FileName );
                for ( int c = 0; c < L.Count; c++ )
                {
                    L[c] = L[c].Trim();
                    string[] arr = L[c].Split(' ');
                    if ( arr.Length == 2 )
                    {
                        string a = arr[0].Trim();
                        string b = arr[1].Trim();

                        int index = LV_DIM_SOURCE.Items.Add( "" ).Index;
                        LV_DIM_SOURCE.Items[index].SubItems.Clear();
                        LV_DIM_SOURCE.Items[index].Text = ( c + 1 ).ToString();
                        LV_DIM_SOURCE.Items[index].SubItems.Add( a );
                        LV_DIM_SOURCE.Items[index].SubItems.Add( b );
                    }
                }
                //
                set_last_dimfile( OD_DICHOTOMY.FileName );
            }
        }

        // fastcalls - buttons process
        private void b_sws_process_Click( object sender, EventArgs e )
        {
            sws_process();
        }
        private void b_dim_process_Click( object sender, EventArgs e )
        {
            dim_process();
        }

        // fastcalls
        private void b_dim_output_Click( object sender, EventArgs e )
        {
            output();
        }
    }
}
